package com.hai.dao;

import com.hai.entity.HighChildOrder;
import com.hai.entity.HighChildOrderExample;
import java.util.List;
import org.apache.ibatis.annotations.Delete;
import org.apache.ibatis.annotations.DeleteProvider;
import org.apache.ibatis.annotations.Insert;
import org.apache.ibatis.annotations.InsertProvider;
import org.apache.ibatis.annotations.Options;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Result;
import org.apache.ibatis.annotations.Results;
import org.apache.ibatis.annotations.Select;
import org.apache.ibatis.annotations.SelectProvider;
import org.apache.ibatis.annotations.Update;
import org.apache.ibatis.annotations.UpdateProvider;
import org.apache.ibatis.type.JdbcType;
import org.springframework.stereotype.Repository;

/**
 * 
 * 代码由工具生成,请勿修改!!!
 * 如果需要扩展请在其父类进行扩展
 * 
 **/
@Repository
public interface HighChildOrderMapper extends HighChildOrderMapperExt {
    @SelectProvider(type=HighChildOrderSqlProvider.class, method="countByExample")
    long countByExample(HighChildOrderExample example);

    @DeleteProvider(type=HighChildOrderSqlProvider.class, method="deleteByExample")
    int deleteByExample(HighChildOrderExample example);

    @Delete({
        "delete from high_child_order",
        "where id = #{id,jdbcType=BIGINT}"
    })
    int deleteByPrimaryKey(Long id);

    @Insert({
        "insert into high_child_order (order_id, goods_type, ",
        "goods_id, goods_name, ",
        "goods_img, goods_spec_name, ",
        "goods_price, sale_count, ",
        "total_price, child_orde_status, ",
        "praise_status, ext_1, ",
        "ext_2, ext_3)",
        "values (#{orderId,jdbcType=BIGINT}, #{goodsType,jdbcType=INTEGER}, ",
        "#{goodsId,jdbcType=BIGINT}, #{goodsName,jdbcType=VARCHAR}, ",
        "#{goodsImg,jdbcType=VARCHAR}, #{goodsSpecName,jdbcType=VARCHAR}, ",
        "#{goodsPrice,jdbcType=REAL}, #{saleCount,jdbcType=INTEGER}, ",
        "#{totalPrice,jdbcType=REAL}, #{childOrdeStatus,jdbcType=INTEGER}, ",
        "#{praiseStatus,jdbcType=INTEGER}, #{ext1,jdbcType=VARCHAR}, ",
        "#{ext2,jdbcType=VARCHAR}, #{ext3,jdbcType=VARCHAR})"
    })
    @Options(useGeneratedKeys=true,keyProperty="id")
    int insert(HighChildOrder record);

    @InsertProvider(type=HighChildOrderSqlProvider.class, method="insertSelective")
    @Options(useGeneratedKeys=true,keyProperty="id")
    int insertSelective(HighChildOrder record);

    @SelectProvider(type=HighChildOrderSqlProvider.class, method="selectByExample")
    @Results({
        @Result(column="id", property="id", jdbcType=JdbcType.BIGINT, id=true),
        @Result(column="order_id", property="orderId", jdbcType=JdbcType.BIGINT),
        @Result(column="goods_type", property="goodsType", jdbcType=JdbcType.INTEGER),
        @Result(column="goods_id", property="goodsId", jdbcType=JdbcType.BIGINT),
        @Result(column="goods_name", property="goodsName", jdbcType=JdbcType.VARCHAR),
        @Result(column="goods_img", property="goodsImg", jdbcType=JdbcType.VARCHAR),
        @Result(column="goods_spec_name", property="goodsSpecName", jdbcType=JdbcType.VARCHAR),
        @Result(column="goods_price", property="goodsPrice", jdbcType=JdbcType.REAL),
        @Result(column="sale_count", property="saleCount", jdbcType=JdbcType.INTEGER),
        @Result(column="total_price", property="totalPrice", jdbcType=JdbcType.REAL),
        @Result(column="child_orde_status", property="childOrdeStatus", jdbcType=JdbcType.INTEGER),
        @Result(column="praise_status", property="praiseStatus", jdbcType=JdbcType.INTEGER),
        @Result(column="ext_1", property="ext1", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_2", property="ext2", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_3", property="ext3", jdbcType=JdbcType.VARCHAR)
    })
    List<HighChildOrder> selectByExample(HighChildOrderExample example);

    @Select({
        "select",
        "id, order_id, goods_type, goods_id, goods_name, goods_img, goods_spec_name, ",
        "goods_price, sale_count, total_price, child_orde_status, praise_status, ext_1, ",
        "ext_2, ext_3",
        "from high_child_order",
        "where id = #{id,jdbcType=BIGINT}"
    })
    @Results({
        @Result(column="id", property="id", jdbcType=JdbcType.BIGINT, id=true),
        @Result(column="order_id", property="orderId", jdbcType=JdbcType.BIGINT),
        @Result(column="goods_type", property="goodsType", jdbcType=JdbcType.INTEGER),
        @Result(column="goods_id", property="goodsId", jdbcType=JdbcType.BIGINT),
        @Result(column="goods_name", property="goodsName", jdbcType=JdbcType.VARCHAR),
        @Result(column="goods_img", property="goodsImg", jdbcType=JdbcType.VARCHAR),
        @Result(column="goods_spec_name", property="goodsSpecName", jdbcType=JdbcType.VARCHAR),
        @Result(column="goods_price", property="goodsPrice", jdbcType=JdbcType.REAL),
        @Result(column="sale_count", property="saleCount", jdbcType=JdbcType.INTEGER),
        @Result(column="total_price", property="totalPrice", jdbcType=JdbcType.REAL),
        @Result(column="child_orde_status", property="childOrdeStatus", jdbcType=JdbcType.INTEGER),
        @Result(column="praise_status", property="praiseStatus", jdbcType=JdbcType.INTEGER),
        @Result(column="ext_1", property="ext1", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_2", property="ext2", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_3", property="ext3", jdbcType=JdbcType.VARCHAR)
    })
    HighChildOrder selectByPrimaryKey(Long id);

    @UpdateProvider(type=HighChildOrderSqlProvider.class, method="updateByExampleSelective")
    int updateByExampleSelective(@Param("record") HighChildOrder record, @Param("example") HighChildOrderExample example);

    @UpdateProvider(type=HighChildOrderSqlProvider.class, method="updateByExample")
    int updateByExample(@Param("record") HighChildOrder record, @Param("example") HighChildOrderExample example);

    @UpdateProvider(type=HighChildOrderSqlProvider.class, method="updateByPrimaryKeySelective")
    int updateByPrimaryKeySelective(HighChildOrder record);

    @Update({
        "update high_child_order",
        "set order_id = #{orderId,jdbcType=BIGINT},",
          "goods_type = #{goodsType,jdbcType=INTEGER},",
          "goods_id = #{goodsId,jdbcType=BIGINT},",
          "goods_name = #{goodsName,jdbcType=VARCHAR},",
          "goods_img = #{goodsImg,jdbcType=VARCHAR},",
          "goods_spec_name = #{goodsSpecName,jdbcType=VARCHAR},",
          "goods_price = #{goodsPrice,jdbcType=REAL},",
          "sale_count = #{saleCount,jdbcType=INTEGER},",
          "total_price = #{totalPrice,jdbcType=REAL},",
          "child_orde_status = #{childOrdeStatus,jdbcType=INTEGER},",
          "praise_status = #{praiseStatus,jdbcType=INTEGER},",
          "ext_1 = #{ext1,jdbcType=VARCHAR},",
          "ext_2 = #{ext2,jdbcType=VARCHAR},",
          "ext_3 = #{ext3,jdbcType=VARCHAR}",
        "where id = #{id,jdbcType=BIGINT}"
    })
    int updateByPrimaryKey(HighChildOrder record);
}